function make_leaf(symbol, weight) {
    return list("leaf", symbol, weight);
}
function is_leaf(object) {
    return head(object) === "leaf";
}
function symbol_leaf(x) { return head(tail(x)); }

function weight_leaf(x) { return head(tail(tail(x))); }
function left_branch(tree) { return head(tail(tree)); }

function right_branch(tree) { return head(tail(tail(tree))); }

function symbols(tree) {
    return is_leaf(tree)
           ? list(symbol_leaf(tree))
           : head(tail(tail(tail(tree))));
}
function weight(tree) {
    return is_leaf(tree)
           ? weight_leaf(tree)
           : head(tail(tail(tail(tail(tree)))));
}
function make_code_tree(left, right) {
    return list("code_tree", left, right,
                append(symbols(left), symbols(right)),
                weight(left) + weight(right));
}
const my_leaf_1 = make_leaf("A", 8);
const my_leaf_2 = make_leaf("B", 3);
const my_tree = make_code_tree(my_leaf_1, my_leaf_2);

weight(my_tree);

const my_leaf_1 = make_leaf("A", 8);
const my_leaf_2 = make_leaf("B", 3);
const my_tree = make_code_tree(my_leaf_1, my_leaf_2);

weight(my_tree);
